/* LDR_test
   Fényérzékelés fotoellenállás (LDR) segítségével,
   amelyet egy feszültségosztó felső tagjának kötónk be.

            LDR      10k
   VCC--/\/\/\-+-/\/\/\--- GND
               |
               A3

   A mért feszültség értékét a soros porton kiíratjuk.
   A programban szereplő 4.66 V helyébe az Arduino kártyán
   mérhető tényleges tápfeszültség értéket kell behellyettesíteni!
*/

void setup () {
  Serial.begin(9600);
  analogReference(DEFAULT);   //VCC a referencia
  Serial.print("Photoresistor");
}

void loop() {
  int sensorValue = analogRead(A0);
  Serial.print("A0 = ");
  Serial.print(sensorValue);
  Serial.print(" V0: ");
  float voltage = sensorValue * 4.66 / 1023;
  Serial.print(voltage, 3);
  float Rx = 10000.0;
  if (sensorValue > 0) {
    Rx = 46.6 / voltage - 10;
  }
  Serial.print(" V Resistance = ");
  Serial.print(Rx, 1);
  Serial.println(" kOhm");
  delay(2000);
}
