/* cds_sensor
 *  
 * Egy LED-ből és egy CdS fotoellenállásból kialakított
 * reflexiós fényérzékelő tesztelése. A LED anódja a
 * D13 kimenetre kapcsolódik, az LDR osztója pedig az
 * A0 analóg bemenetre van kötve.
 * 
 * A fényérzékeny osztó felső tagja a CdS ellenállás, 
 * alsó tagja pedig egy 10 kOhmos ellenállás.
 * A LED előtétellenállása itt 470 Ohm, amit az érzékenység
 * növelése érdekében még lehetne csökkenteni (220 vagy 100 Ohmra).
 * 
 * A környezeti hatások kiszűrése érdekében két mérést végzünk:
 * bekapcsolt és kikapcsolt LED-del, s a két mérés különbségét vesszük.
 * A zaj kiátlagolására egy-egy mérésnél 500 adatot átlagolunk.
 * 
 * Tested with Arduino IDE 1.8.13
 */

long meres(int pin1, int pin2, int n) {
  long sum1=0, sum2=0, difi;
  digitalWrite(pin1, HIGH);
  for(int i=0; i<n; i++) {
    sum1 += analogRead(pin2); 
  }
  digitalWrite(pin1, LOW);
  for(int i=0; i<n; i++) {
    sum2 += analogRead(pin2); 
  }
  difi = (sum1 - sum2)/n;
  return difi;  
}

void setup() {  
  Serial.begin(9600); 
  analogReference(DEFAULT);
  pinMode(13, OUTPUT);
  digitalWrite(13,LOW);
}

void loop() {  
  long a = meres(13,A0, 500);
  Serial.print("A = ");
  Serial.println(a);
  delay(500);
}
